<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';
//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    // !isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;


$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

function getAnnouncement($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $search_string, $from_date, $to_date, $limit, $offset)
{

    $sql_count = "SELECT  count(*) as total_rows FROM  announcement  where institution_id =? AND (branch_id = ? or branch_id='all')";
    $array_params = [$institution_id, $branch_id];
    
    if ($class_id == 'all') {
            $sql_count .= "";
    } else if ($class_id !=  null  && $class_id != 'all') {
            $sql_count .= " AND (class_id = ? or class_id ='all') ";
            $array_params[] = $class_id;
    }

    if ($section_id == 'all') {
            $sql_count .= "";
    } else if ($section_id !=  null  && $section_id != 'all') {
            $sql_count .= " AND (section_id = ? or section_id ='all')";
            $array_params[] = $section_id;
    }
    if ($search_string != null) {
            $sql_count .= " AND (title LIKE ? OR message LIKE ?)  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
    }

        // Add date range condition
   if ($from_date != null && $to_date != null) {
            $sql_count .= " AND date_created BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
    }

    $stmt = $conn_rjllearning_specific->prepare($sql_count);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];

    if ($limit == 'all') {
        $sql = "SELECT * FROM announcement WHERE institution_id = ? AND (branch_id = ? or branch_id='all')";
        $array_params = [$institution_id, $branch_id];

        if ($class_id == 'all') {
            $sql .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql .= " AND (class_id = ? or class_id ='all') ";
            $array_params[] = $class_id;
        }

        if ($section_id == 'all') {
            $sql .= "";
        } else if ($section_id !=  null  && $section_id != 'all') {
            $sql .= " AND (section_id = ? or section_id ='all')";
            $array_params[] = $section_id;
        }
        if ($search_string != null) {
            $sql .= " AND (title LIKE ? OR message LIKE ?)  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }

        // Add date range condition
        if ($from_date != null && $to_date != null) {
            $sql .= " AND date_created BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
        }
        $sql .=  "order by date_created desc, time_created desc";
    } else {

        $sql = "SELECT * FROM announcement WHERE institution_id = ? AND (branch_id = ? or branch_id='all') ";
        $array_params = [$institution_id, $branch_id];

        if ($class_id == 'all') {
            $sql .= "";
        } else if ($class_id !=  null  && $class_id != 'all') {
            $sql .= " AND  (class_id = ? or class_id ='all')  ";
            $array_params[] = $class_id;
        }

        if ($section_id == 'all') {
            $sql .= "";
        } else if ($section_id !=  null  && $section_id != 'all') {
            $sql .= " AND (section_id = ? or section_id ='all')";
            $array_params[] = $section_id;
        }

        if ($search_string != null) {
            $sql .= " AND (title LIKE ? OR message LIKE ?)  ";
            $array_params[] = '%' . $search_string . '%';
            $array_params[] = '%' . $search_string . '%'; // Append to $array_params
        }

        // Add date range condition
        if ($from_date != null && $to_date != null) {
            $sql .= " AND date_created BETWEEN ? AND ?";
            $array_params[] = $from_date;
            $array_params[] = $to_date;
        }
        $sql .= " order by date_created desc, time_created desc ";
        $sql .= "LIMIT " . $offset . " ," . $limit . "";
    }
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();

    $array_return = [];

    foreach ($result as $rows) {

        if ($rows['attachment'] != null and !is_array($rows['attachment'])) {
            $data_attachment = json_decode($rows['attachment'], true);
            $filePath = $data_attachment['filepath'];
            $originalName = $data_attachment['original_name'];
            $aws_attachment = displayFileFromS3($GLOBALS['s3_learning_bucket'], $GLOBALS['learning_bucketName'], $filePath);
            $final_array_attachment   = array("filepath" => $aws_attachment, "original_name" => $originalName);
        } else {
            $final_array_attachment =  null;
        }

        // $branch_info =  getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        if ($rows['branch_id'] == 'all') {
            $branch_info = array('branch_id' => 'all', 'name' => ucwords('all'));
        } else {
            $branch_info = getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        }

        if ($rows['class_id'] == 'all') {
            // Corrected array syntax
            $class_info = ['class_id' => 'all', 'class_name' => ucwords('all')];
        } else {
            // Call the getClass function to fetch class information
            $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['class_id']);
        }

        if ($rows['section_id'] === 'all') {
            // Corrected array syntax
            $section = ['section_id' => 'all', 'section_name' => ucwords('all')];
        } elseif ($rows['section_id']) {
            // If section_id is an array, fetch sections using getSection function
            $section = getSection($conn_rjllearning_specific, $institution_id, $rows['section_id']);
        }

        // $class_info = getClass($conn_rjllearning_specific, $institution_id, $rows['class_id']);
        // $section =getSection($conn_rjllearning_specific, $institution_id, $rows['section_id']);
        // $branch_info =  getBranchInfo($conn_rjllearning_specific, $institution_id, $rows['branch_id']);
        $array_return[] = array('announcement_id' => $rows['id'], 'branch_id' => $branch_info, 'class_id' => $class_info, 'section_id' => $section, 'title' => $rows['title'], 'message' => $rows['message'], 'attachment' => $final_array_attachment, 'date_created' => $rows['date_created']);
    }

    if (count($result) < 50) {
        return array('total_rows' => $totalrows, 'announcement_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'announcement_info' => $array_return, 'maxreach' => 0);
    }
}


if ($postdata['function_type'] == "fetch_announcement") {


    if (isset($postdata['class_id']) and !empty($postdata['class_id'])) {
        $class_id = trim($postdata['class_id']);
    } else {
        $class_id = null;
    }
    if (isset($postdata['section_id']) and !empty($postdata['section_id'])) {
        $section_id = trim($postdata['section_id']);
    } else {
        $section_id = null;
    }
    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    if (isset($postdata['from_date']) and !empty($postdata['from_date'])) {
        $from_date = trim($postdata['from_date']);
    } else {
        $from_date = null;
    }
    if (isset($postdata['to_date']) and !empty($postdata['to_date'])) {
        $to_date = trim($postdata['to_date']);
    } else {
        $to_date = null;
    }
    if ($from_date > $to_date) {
        errorreturn('Invalid Date format');
    }
    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    if ($check_academic_confirmation != true) {
        errorreturn("Access denied. Academic session not active.");
    }

    if ($limit != 'all') {
        $offset = ($page - 1) * $limit;
        $success['data'] = getAnnouncement($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $search_string, $from_date, $to_date, $limit, $offset);
        successreturn($success);
    } else {
        $success['data'] = getAnnouncement($conn_rjllearning_specific, $institution_id, $branch_id, $class_id, $section_id, $search_string, $from_date, $to_date, $limit, null);
        successreturn($success);
    }
}
